Name:			elektra
Version:		0.4.6
%define myRelease	2%{_my_ext}
%define vepoch	1
Vendor:			%{vendor}
Packager:		%{packager}
Distribution:		%{distribution}

Release:       0.%{vepoch}.%{myRelease}
Source:        http://aleron.dl.sourceforge.net/sourceforge/elektra/%{name}-%{version}.tar.gz
Group:         System Environment/Libraries
License:       BSD
URL:           http://elektra.sf.net
Obsoletes:     registry
Provides:      registry
BuildRoot:     %{_tmppath}/%{name}-%{version}-build
BuildRequires: /usr/bin/xsltproc
Summary:       A key/value pair database to store software configurations

%description
The Elektra Project provides a framework to store generic configuration data
in an hierarchical key-value pair database, instead of a human-readable only
text file.

This way any software can read/save his configuration using a consistent API.
Also, applications can be aware of other applications configurations,
leveraging easy application integration.


%package devel
Summary:      Include files and API documentation for Elektra Project
Group:        Development/System
Requires:     elektra = %{version}-%{release}
Obsoletes:    registry-devel
Provides:     registry-devel

%description devel
The Elektra Project provides a framework to store generic configuration data
in an hierarchical key-value pair database, instead of a human-readable only
text file.

This way any software can read/save his configuration using a consistent API.
Also, applications can be aware of other applications configurations,
leveraging easy application integration.

This package contains the include files and API manual pages to use the Elektra
API in C.

%prep
%setup -n elektra
%build
# Setup for parallel builds
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
	numprocs=1
fi

gmake %{?_smp_mflags} all

%install
gmake  %{?_smp_mflags} DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT/*
rm -rf $RPM_BUILD_DIR/%{name}




%post -p /sbin/ldconfig
# Backwards compatibility, from the Linux Registry days
if [ -d /etc/registry -a ! -d /etc/kdb ]; then
	mv /etc/registry /etc/kdb
	ln -s kdb /etc/registry
fi

# Create basic key structure for apps
kdb set -t dir system/sw


%postun -p /sbin/ldconfig



%files
%defattr(-,root,root,0755)
/lib/*.so
/bin/*
/etc/profile.d/*
%doc /usr/share/doc/%{name}
%doc /usr/share/man/man1/*
%doc /usr/share/man/man7/*
%doc /usr/share/man/man5/*
/usr/share/sgml/*



%files devel
%defattr(-,root,root,0755)
/usr/include/*
/usr/lib/*.a
%doc /usr/share/doc/%{name}-devel
%doc /usr/share/man/man3/*

%changelog
* Sun Dec 19 2004  Scott Grayban <sgrayban@borgnet.us> 0.4.6-2bgn
 - rebuild for right extension

* Fri Nov 26 2004 Scott Grayban <sgrayban@borgnet.us>
- Rebuilt for MDK10.1
- Paths are different for Mandrake

* Fri Nov 05 2004 Avi Alkalay <avi@unix.sh> 0.4.6
- New method: kdbRename()
- Updates to spec files, to conform to Fedora conventions
- First GPG sign
- Ready to be sent to fedora.us

* Mon Nov 02 2004 Avi Alkalay <avi@unix.sh> 0.4.5
- Fixed a bug in kdbGetKeyByParentKey()
- Changed the behavior of kdbSetKeys(): now developer may know where errors occured
- Changed kdb to to fit new kdbSetKeys behavior
- Small fixes in the doxygen documentation, improved code examples
- More efficient documentation build

* Sun Oct 25 2004 Avi Alkalay <avi@unix.sh> 0.4.4
- Added documentation on how to write new backends
- Fixed "kdb get" when getting binary values
- Fixed a bug when converting binary key values to hex digits
- Fixed a bug in the reverse way: from hex to binary (jens)
- Added -b to kdb, to set key values with the content of a file
- Trying to fix something wrong in kdbGetKey()

* Wed Sep 22 2004 Avi Alkalay <avi@unix.sh> 0.4.3
- Removed kdbOption instantiation from kdb.h

* Sun Sep 12 2004 Avi Alkalay <avi@unix.sh> 0.4.2
- Fixed a gzip problem in the build system
- Added ksGetSize() method

* Tue Sep 09 2004 Avi Alkalay <avi@unix.sh> 0.4.1
- Fixed some wrong charset handling
- License changed to BSD
- Updates to documentation

* Tue Aug 31 2004 Avi Alkalay <avi@unix.sh> 0.4
- Name changed to Elektra
- rg command changed to kbd
- registry.h to kdb.h
- libregistry.so to libkbd.so
- The former still provided as a wrapper for binary compatibility
- Most #defines now are enums
- Enums now documented
- "*NameSpace()" to "*Namespace()"
- Appeared keyClearFlag()
- Changed documentation due to new name
- Greatly improved documentation. It is now 100% complete
- API man pages are now from Doxygen
- Tested build in BSD: iconv is a separate library there
- Changed some error codes for BSD compatibility
- Used the "const" parameter modifier everyplace that is needed
- 'kdb export' now allways exports as UTF-8, regardeless of current encoding
- 'kdb get' now has a shell mode with -s option
- elektrasetenv now uses the new 'kdb get' command, and it is less comples
- elektrasetenv now set environment from system/env and user/env
- Changes in the XML DTD header due to web site change

* Mon Aug 17 2004 Avi Alkalay <avi@unix.sh> 0.3.1
- Fixed a bug in keyToStream() regarding XML export of comments
- Make rg.c compile with older XML library
- .spec now uses gmake instead of make
- Moved ENODATA to ENOMSG, for better BSD compatibility
- Improved the README documentation with packaging info

* Mon Aug 10 2004 Avi Alkalay <avi@unix.sh> 0.3
- Registry now supports key and key sets CHANGE NOTIFICATIONS
- New 'rg monitor' command, using notifications framework
- 100% fully documented methods with Doxygen
- Thinking seriously in a project name change. I have an idea for a new name

* Fri Jul 30 2004 Avi Alkalay <avi@unix.sh> 0.2.9
- Doxygen finaly generates methods documentation. Not very nice though.
- Included in -devel RPM
- Included Advogato project page in the documentation

* Sun Jul 25 2004 Avi Alkalay <avi@unix.sh> 0.2.8
- Added the export and import subcommands to rg.
- Updated man page for that.
- Build environments that don't have xsltproc and the DocBook styles won't fail to build manual pages.

* Thu Jul 4 2004 Avi Alkalay <avi@unix.sh> 0.2.7
- First atempt to workaround the manpage creation when XSL tools are not available.

* Thu Jun 24 2004 Avi Alkalay <avi@unix.sh> 0.2.6
- Moved responsability of creating dirs in the installation process from spec to Makefile.
- Detected a problem of manpage creation in other distros, thanks to Tim Witham from OSDL. Not fixed yet.

* Sat Jun 02 2004 Avi Alkalay <avi@unix.sh> 0.2.5
- Fixed the absense of keyClose in some places. Thanks to Victor.
- In registryStatKey(), handled error if file can't be found. Thanks to Jens Andersen.
- keyInit is now less smart: it will not test if the key is initialized or not. This is now a programmer responsability.
- Code migrated to Subversion, thanks to Sean Russel. http://germane-software.com/repositories/tlr/
- Added $Id: etc to source files.
- Added 'make commit' to deal with 'svn ci'

* Sat May 22 2004 Avi Alkalay <avi@unix.sh> 0.2.4
- Improved rgsetenv login script: now set aliases too.
- New methods: registryGetKeyByParent, registryGetKeyByParentKey, registryGetValueByParent, registrySetValueByParent
- First attempts to create a bianry 'rg' with libxml statically linked.
- New libregistry.a provided in -devel package, for creation of static binaries.
- API manpages can now be accessed by method name (example: man registryGetKey)


* Thu May 06 2004 Avi Alkalay <avi@unix.sh> 0.2.3
- Defined an XML DTD for keys
- Defined keyToStream() and ksToStream() that dumps a key or keyset to XML format
- Defined keyCompare() and ksCompare()
- New 'rg edit' subcommand, to XML edit subtrees of the Regitry
- Improved registryGetChildKeys() for better handling of symlinks
- An /etc/profile.d script to set user environment is available in package now
- New "Society of Softwares" section in documentation
- Improved CSS of the HTML documentation

	
* Thu Apr 13 2004 Avi Alkalay <avi@unix.sh> 0.2.2
- Implemented -u and -g in rg command to set Key UID and GID.
- Included RG_O_SORT option for registyrGetChildKeys, to returned a KeySet sorted by key name.
- Now every user/* key has an associated Owner defined, which defaults to $USER, when not specified in keySetName().
- Upgrade in the key file format. Changes in the data type field.
- New handleOldKeyFileVersion() to keep backwards compatibility with older key files.
- Updates to documentation for this version changes.
- Symbolic links between keys are now consolidated. There is a formal key type for them: RG_KEY_TYPE_LINK
- Fixed a minor problem related to reading last \n in key comments
- Updated userd-convert script to be make a more NIS compatible conversion
- Included a new migration script: hwconfingKudzu-convert. To migrate kudzu data to the registry


* Thu Apr 06 2004 Avi Alkalay <avi@unix.sh> 0.2.1
- Change in key names: instead of (.) as hierarchy delimitator, we have (/) now. This is better for POSIX file name compliancy.
- Consolidation of inactive keys.
- Updates to documentations to include inactive keys concepts, etc.
- Written key.3 manual page for key*() methods.
- New conversion script to convert /etc/fstab
- Removed a bug in UTF8Engine(). Data was written with a \n in the end. Thanks to Jens Andersen.

* Thu Apr 01 2004 Avi Alkalay <avi@unix.sh> 0.1.6
- Introduction to inactive keys
- registryGetChildKeys by default do not include inactive keys in resulting KeySet. Use RG_O_INACTIVE instead.
- rg.c changed, specially in the list subcommand, to work with new behavior

* Wed Mar 31 2004 Avi Alkalay <avi@unix.sh> 0.1.5
- Fixed in registryGetKey: Keys allways needed sync
- Fixed bug releated to NEEDSYNC: ~RG_KEY_FLAG_NEEDSYNC needed a special cast to use the right number of bits
- Improved HOWTO documentation and manual. Link to ReiserFS.
- Started writting of the key.3 manual
- One more bug related to strblen in registryFileUnserialize(), causing wrong data size calculation

* Mon Mar 29 2004 Avi Alkalay <avi@unix.sh> 0.1.4
- Written manual pages rg(1), registry(7), registry(5) and registry(3) using DocBook
- Ported the OpenOffice.org specification to DocBook, using the modularized man pages
- RPMs include manpages
- RPMs have prerequesites now
- Fixed bug regarding \0 in end of key names on recursive stats
- More robust build system, catching warnings
- New method: registryGetRootKeys(KeySet *returned)
- Fixed some bugs related to usage of strblen()
- Introduction of the RG_O_* method options
- Removed bug related to permission when stat()ing keys
- Removed bugs in some KeySet methods
- Much improved 'rg ls' command, specially in recursive mode
- New key flag, NEEDSYNC, to indicate the change status of a key
- New method, registrySetKeys, to commit all modified keys on a KeySet

* Tue Mar 16 2004 Avi Alkalay <avi@unix.sh> 0.1.2
- The Linux Registry API is 100% usable
- The rg command is very usable
- Full support to UTF-8. Everything stored in the registry is UTF-8, regardeless of user's LANG. Conversions are on the fly.
- Fixed bug on keySetName(), regarding wrong keyNameSize
- Introduction of registryRemoveKey()
- rg subcommands: ls, get, set, rm
- rg now supports set octal permissions from command line
- Key and Registry support for DIR type
- Documentation process (man pages) in the very begining
- Include files in a separate package

* Sat Mar 06 2004 Avi Alkalay <avi@unix.sh> 0.0.9
- Now no more IPC, Berkeley DB, threads, setuid, and other complexities
- Simple library that accesses files on disk
- rg has 'set' and partial 'ls' subcommands implemented
- API can already be used

* Sat Feb 15 2004 Avi Alkalay <avi@unix.sh> 0.0.2
- Based on IPC, Berkeley DB, Threads, and many other complexities
